﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using TrieApp.model;
using TrieApp.view_model;

namespace TrieApp
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		Microsoft.Win32.OpenFileDialog dlgOpenFile;

		public MainWindow()
		{
			InitializeComponent();
		}

		private void openFile_Click(object sender, RoutedEventArgs e)
		{
			TrieVm		vm	= this.btn_openFile.DataContext as TrieVm;

			if(vm == null || vm.LoadSampleTextCommand == null || ! vm.LoadSampleTextCommand.CanExecute(null))
				return;

			// Configure open file dialog box 
			if(dlgOpenFile == null)
			{
				dlgOpenFile					= new Microsoft.Win32.OpenFileDialog();
				dlgOpenFile.CheckFileExists	= true;
				dlgOpenFile.DefaultExt		= ".txt";						// Default file extension 
				dlgOpenFile.Filter			= "Text files (.txt)|*.txt;";	// Filter files by extension 
			}

			// use last directory
			if(! string.IsNullOrEmpty(dlgOpenFile.FileName))
				dlgOpenFile.InitialDirectory = System.IO.Path.GetDirectoryName(dlgOpenFile.FileName);

			dlgOpenFile.FileName	= "";							// Default file name 

			// Show open file dialog box 
			bool?		result	= dlgOpenFile.ShowDialog();

			// Process open file dialog box results 
			if (result != true)
				return;

			// Open document 
			string			filename	= dlgOpenFile.FileName;

			if( string.IsNullOrEmpty(filename))
				return;

			vm.SampleFileName = filename;
			//this.wordCountloadingValues.Visibility = Visibility.Visible;
			vm.LoadSampleTextCommand.Execute(null);
		}
	}
}
