﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using isosoft.root;

namespace TrieApp.model
{
	public class CharDictionary : XObjectListNotifier<CharDictionaryItem>
	{


		public CharDictionary() : base()
		{

		}

		public CharDictionaryItem this[char c]
		{
			get { return this.FirstOrDefault( i => i.Character == c); }
		}


		public CharDictionaryItem AddTail(char c, bool notifyChanges)
		{
			CharDictionaryItem	item	= this[c];
			CharDictionaryItem	last	= this.LastItem;

			if(item == null)
			{
				item = new CharDictionaryItem(c, this.LastItem, null);
				this.Add(item);
			}
				
			else
			{
				item.Previous	= last;
				// item.Next		= null;
			}

			if(last != null)
				last.Next = item;

			if(notifyChanges)
				NotifyCollectionChanged(this);
			return item;
		}

		public CharDictionaryItem LastItem
		{
			get { return this.Count <= 0 ? null : this[this.Count - 1]; }
		}
	}
}
