﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using TrieApp.model.root_objects;

namespace TrieApp.model
{
	public class CharDictionaryItem : DoubleChainedNode<CharDictionaryItem>
	{
		char			_character;

		public CharDictionaryItem() : base()
		{

		}

		public CharDictionaryItem(char character, CharDictionaryItem prev, CharDictionaryItem next) : base(prev, next)
		{
			_character = character;
		}

		public char Character
		{
			get {  return _character; }
			set
			{
				if(value == _character)
					return;

				_character = value;
				NotifyPropertyChanged(() => Character);
				NotifyPropertyChanged(() => CharValue);
			}
		}

		public int CharValue
		{
			get {  return _character; }
		}
	}
}
