﻿//using GalaSoft.MvvmLight.Threading;
using System;
using System.Collections.Generic;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Input;
using System.Windows.Threading;

namespace isosoft.root
{
	public class CommandExecuter : ICommand
	{
		/*readonly*/ Action			_execAction;
		/*readonly*/ Func<bool>		_canExecute;
		Action						_callBack;
		//SynchronizationContext		_syncContext;
		Dispatcher					_dispatcher;
		bool						_async			= false;

		public CommandExecuter(Action execute) : this(execute, null, false, Dispatcher.CurrentDispatcher /*SynchronizationContext.Current*/, null)
		{
		}

		public CommandExecuter(Action execute, Func<bool> canExecute, bool execAsync, Dispatcher targetDispatcher /*SynchronizationContext syncContext*/, Action callBack)
		{
			_execAction		= execute;
			_canExecute		= canExecute;
			//_syncContext	= syncContext;
			_dispatcher		= targetDispatcher;
			_async			= execAsync;
			_callBack		= callBack;
		}

		//public SynchronizationContext SyncContext
		//{
		//	get {  return _syncContext; }
		//	set {  _syncContext = value; }
		//}

		public Dispatcher TargetDispatcher
		{
			get { return _dispatcher; }
			set { _dispatcher = value; }
		}


		public bool IsAsync
		{
			get {  return _async; }
			set {  _async = value; }
		}

		#region ICommand Members

		public bool CanExecute(object parameter) // parameter ignored
		{
			return _canExecute == null || _canExecute();
		}

		public event EventHandler CanExecuteChanged
		{
			add		{ CommandManager.RequerySuggested += value; }
			remove	{ CommandManager.RequerySuggested -= value; }
		}


		public void Execute(object parameter) // parameter ignored
		{
			if(_execAction == null)
				return;

			if(_async)
			{
				ExecuteAsnc();
				return;
			}

			//DispatcherHelper.CheckBeginInvokeOnUI( _execAction);
			//_execAction.BeginInvoke(_ => {}, null);	//.Invoke();
			_execAction();
		}

		public void ExecuteAsnc()
		{
			if (_execAction == null)
				return;

			TaskScheduler	currentSccheduler	= TaskScheduler.FromCurrentSynchronizationContext();

			if (_dispatcher != null)		// _syncContext != null)
			{

				//var				tcs					= new TaskCompletionSource<bool>();
				//_syncContext.Post(delegate
				//{

				List<Task>	tasks	= new List<Task>();
				Task	task1	=
					Task.Factory.StartNew(
						() =>							// this will use current synchronization context
						{
							//_syncContext.Send(delegate
							{
								_execAction.Invoke();
							//(_) => */
							//{
								//if (_callBack != null)
								//	_callBack.Invoke(); 
							}
							//	, null);
								
						},
						CancellationToken.None,
						TaskCreationOptions.None,
						currentSccheduler);

				tasks.Add(task1);

				task1.ContinueWith( (i) => 
					{
						if(_callBack != null)
							_dispatcher.BeginInvoke( (Action)(() => { _callBack(); }), null);
					}
					,
					CancellationToken.None,
					TaskContinuationOptions.OnlyOnRanToCompletion,
					currentSccheduler);

					//_execAction.Invoke();
					////(_) =>
					//{
					//	if (_callBack != null)
					//		_callBack.Invoke();
					//}
					////, null);
				//}, null);
			}
			else
			{
				Task.Factory.StartNew(
					() =>							// this will use current synchronization context
					{
						_execAction.BeginInvoke((_) => { if(_callBack != null) _callBack.Invoke(); }, null);
					},
					CancellationToken.None,
					TaskCreationOptions.None,
					currentSccheduler);
			}
		}

#endregion // ICommand Members
	}
}
