﻿using isosoft.root;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace TrieApp.model.root_objects
{
	public class DoubleChainedNode<T> : XObjectNotifier where T : class
	{
		//DoubleChainNode<T>
		T					_previous,
							_next;

		public DoubleChainedNode()
		{

		}

		public DoubleChainedNode(T prev, T next)
		{
			_previous	= prev;
			_next		= next;
		}

		public T Previous
		{
			get {  return _previous; }
			set
			{
				if(value == _previous)
					return;

				_previous = value;
				NotifyPropertyChanged(() => Previous);
			}
		}

		public T Next
		{
			get { return _next; }
			set
			{
				if (value == _next)
					return;

				_next = value;
				NotifyPropertyChanged(() => Next);
			}
		}


		//public void Detatch()
		//{
		//	if(_previous != null)
		//		_previous.Next	= _next;

		//	if(_next != null)
		//		_next.Previous	= _previous;
		//}
	}
}
